<?php

/**
 * Page centrale de gestion des paramètres d'un utilisateur et du portail lui-même.
 */

 require_once ($_SERVER["DOCUMENT_ROOT"]."/services/fonctions/bdd/utilisateurs.php");
 
 $liste_utilisateurs = listeUtilisateursPostfix($pdo);
 
/**
* Affiche le formulaire de selection d'un utilisateur si celui connecté possède les privilèges administrateur.
*/
if (testPrivileges()=="administrateur") {
	echo <<<_HEREDOC_
<div class="row">
	<div class="col-12 col-md-6">
		<div class="card  mt-4">
			<div class="card-body">
				<h5 class="card-title">Choix de l'adresse</h5>
				<form id="form_choix_utilisateur" action="/services/traitements/utilisateurs/changeUtilisateur.php" method="post">
					<select class="form-select" name="choix_utilisateur" onchange="autoSoumission(this);">
_HEREDOC_;

				/**
				 * Remplis un menu déroulant permettant le choix de l'utilisateur par l'administrateur.
				 * Ce choix permettra de modifier les données y étant rattachés.
				 * La valeur par défaut du menu est positionnée sur le compte administrateur actuellement connecté.
				 */
				foreach ($liste_utilisateurs as $utilisateur_bdd => $utilisateur) {
					if ($utilisateur['utilisateur']==$_SESSION['pseudo_utilisateur']) {
						echo "<option value=\"".$utilisateur['utilisateur']."\" selected>".$utilisateur['utilisateur']."</option>\n";
					}
					elseif ($_SESSION['privilege_utilisateur']=="administrateur") {
						echo "<option value=\"".$utilisateur['utilisateur']."\">".$utilisateur['utilisateur']."</option>\n";
					}
				}

				echo <<<_HEREDOC_
					</select>
					<input type="hidden" name="page_origine" value="parametres">
				</form>
			</div>
		</div>
	</div>
_HEREDOC_;
}

/**
* Changement du mot de passe d'un utilisateur.
*/

?>
	<div class="col-12 col-md-6">
		<div class="card mt-4">
			<div class="card-body">
				<h5 class="card-title">Mot de passe</h5>
				<form action="/services/traitements/utilisateurs/changeMotDePasseUtilisateur.php" method="post">
					<div class="input-group">
						<?php if ($_SESSION['privilege_utilisateur']=="utilisateur") { echo '<input type="password" class="form-control" name="ancien_mot_de_passe" placeholder="Ancien mot de passe" required>'; } ?>
						<input type="password" class="form-control" name="nouveau_mot_de_passe" placeholder="Nouveau mot de passe" required>
						<input type="password" class="form-control" name="confirmation_mot_de_passe" placeholder="Confirmation mot de passe" required>
						<button class="btn btn-primary bouton-ajout" type="submit"><img src="/fichiers/svg/plus.svg"/></button>
					</div>
				</form>
			</div>
		</div>
	</div>
</div>